marmix/stocks/urls.py
# -*- coding: UTF-8 -*-
# urls.py
#
# Copyright (C) 2014 HES-SO//HEG Arc
#
# Author(s): Cédric Gaspoz <cedric.gaspoz@he-arc.ch>
#
# This file is part of MarMix.
#
# MarMix is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# MarMix is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with MarMix. If not, see <http://www.gnu.org/licenses/>.

# Stdlib imports

# Core Django imports
from django.conf.urls import patterns, url

# Third-party app imports

# MarMix imports
from .views import StockListView, StockDetailView, HoldingsView, OrderCreateView, OrderUpdateView, OrderListView, OrderDeleteView, DividendsView

urlpatterns = patterns('',
    url(r'^(?P<pk>\d+)/$', StockDetailView.as_view(), name='stocks-detail-view'),
    url(r'^holdings/$', HoldingsView.as_view(), name='holdings-list-view'),
    url(r'^dividends/$', DividendsView.as_view(), name='dividends-list-view'),
    url(r'^order/(?P<pk>\d+)/update/$', OrderUpdateView.as_view(), name='order-update-view'),
    url(r'^order/(?P<pk>\d+)/delete/$', OrderDeleteView.as_view(), name='order-delete-view'),
    url(r'^order/new/$', OrderCreateView.as_view(), name='order-create-view'),
    url(r'^order/$', OrderListView.as_view(), name='orders-list-view'),
    url(r'^$', StockListView.as_view(), name='stocks-list-view'),
)

marmix/urls.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.conf import settings
from django.conf.urls import patterns, include, url
from django.conf.urls.static import static
from django.views.generic import TemplateView

# Uncomment the next two lines to enable the admin:
from django.contrib import admin
admin.autodiscover()
import permission
permission.autodiscover()
from simulations.views import RankingView
from django.contrib.flatpages.sitemaps import FlatPageSitemap
from django.contrib.sitemaps.views import sitemap
from sitemaps import StaticViewSitemap

sitemaps = {
    'flatpages': FlatPageSitemap,
    'static': StaticViewSitemap,
}

urlpatterns = patterns('',
    url(r'^$',  # noqa
        TemplateView.as_view(template_name='pages/home.html'),
        name="home"),
    url(r'^contact/', include('envelope.urls')),
    # Uncomment the next line to enable the admin:
    url(r'^admin/', include(admin.site.urls)),

    # User management
    url(r'^users/', include("users.urls", namespace="users")),
    url(r'^accounts/', include('allauth.urls')),

    # Uncomment the next line to enable avatars
    url(r'^avatar/', include('avatar.urls')),

    # MarMix apps urls
    url(r'^stocks/', include('stocks.urls')),
    url(r'^customers/', include('customers.urls')),
    url(r'^simulations/', include('simulations.urls')),
    url(r'^tickers/', include('tickers.urls')),
    url(r'^ranking/(?P<pk>\d+)/', RankingView.as_view(), name='ranking-view'),
    url(r'^pages/', include('django.contrib.flatpages.urls')),
    url(r'^sitemap\.xml$', sitemap, {'sitemaps': sitemaps},
        name='django.contrib.sitemaps.views.sitemap'),
    url(r'^robots\.txt', include('robots.urls')),

) + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

urlpatterns += patterns('django.contrib.flatpages.views',
    url(r'^about/$', 'flatpage', {'url': '/about/'}, name='about'),
    url(r'^help/$', 'flatpage', {'url': '/help/'}, name='help'),
    url(r'^sitemap/$', 'flatpage', {'url': '/sitemap/'}, name='sitemap'),
    url(r'^start/$', 'flatpage', {'url': '/start/'}, name='start'),
)

from django.conf.urls import url, include
from simulations.views import SimulationViewSet, CurrencyViewSet, TeamViewSet, ClockViewSet
from stocks.views import StockViewSet, QuoteViewSet, OrderViewSet, HoldingsViewSet, CreateOrderViewSet, DividendsViewSet, MarketViewSet, OrderBookViewSet
from users.views import UserViewSet, LoginView, current_user
from tickers.views import CompaniesViewSet
from rest_framework.routers import DefaultRouter


# Create a router and register our viewsets with it.
router = DefaultRouter()
router.register(r'simulations', SimulationViewSet)
router.register(r'currencies', CurrencyViewSet)
router.register(r'users', UserViewSet)
router.register(r'stocks', StockViewSet, base_name='stock')
router.register(r'quotes', QuoteViewSet)
router.register(r'teams', TeamViewSet)
router.register(r'orders', OrderViewSet, base_name='order')
router.register(r'order', CreateOrderViewSet, base_name='create-order')
router.register(r'holdings', HoldingsViewSet, base_name='holdings')
router.register(r'clock', ClockViewSet, base_name='clock')
router.register(r'tickers', CompaniesViewSet, base_name='ticker')
router.register(r'dividends', DividendsViewSet, base_name='dividend')
router.register(r'market', MarketViewSet, base_name='market')
router.register(r'book', OrderBookViewSet, base_name='book')

# The API URLs are now determined automatically by the router.
# Additionally, we include the login URLs for the browsable API.
urlpatterns += [
    url(r'^api/v1/', include(router.urls)),
    url(r'^api-auth/', include('rest_framework.urls', namespace='rest_framework')),
    url(r'^api/v1/auth/login/$', LoginView.as_view(), name='login'),
    url(r'^api/v1/current-user/$', current_user, name='current_user'),
]

marmix/stocks/models.py
# -*- coding: UTF-8 -*-
# models.py
#
# Copyright (C) 2014 HES-SO//HEG Arc
#
# Author(s): Cédric Gaspoz <cedric.gaspoz@he-arc.ch>
#
# This file is part of MarMix.
#
# MarMix is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# MarMix is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with MarMix. If not, see <http://www.gnu.org/licenses/>.

# Stdlib imports
from decimal import Decimal, getcontext

# Core Django imports
from django.db import models, transaction
from django.utils.translation import ugettext_lazy as _
from django.db import connection

# Third-party app imports
from django_extensions.db.models import TimeStampedModel
import django_filters

# MarMix imports
from simulations.models import Simulation, Team, current_sim_day, stock_historical_prices, current_cash, current_shares
from .tasks import check_matching_orders, set_stock_quote, set_opening_price


def dictfetchall(cursor):
    """
    Returns all rows from a cursor as a dict

    :param cursor:
    :return:
    """
    desc = cursor.description
    return [
        dict(zip([col[0] for col in desc], row))
        for row in cursor.fetchall()
    ]


def simulation_quotes_history(simulation_id):
    cursor = connection.cursor()
    cursor.execute('SELECT * '
                   'FROM quotes_history '
                   'WHERE simulation_id=%s', [simulation_id, ])
    quotes_history = dictfetchall(cursor)
    return quotes_history


class Stock(TimeStampedModel):
    """
    Stocks are shares of a company that are automatically generated during the simulation setup.
    """
    simulation = models.ForeignKey(Simulation, verbose_name=_("simulation"), related_name="stocks", help_text=_("Related simulation"))
    symbol = models.CharField(verbose_name=_("symbol"), max_length=4, help_text=_("Symbol of the stock (4 chars)"))
    name = models.CharField(verbose_name=_("name"), max_length=100, help_text=_("Full name of the stock"))
    description = models.TextField(verbose_name=_("description"), blank=True, help_text=_("Description of the stock (HTML)"))
    quantity = models.IntegerField(verbose_name=_("quantity"), default=1, help_text=_("Total quantity of stocks in circulation"))
    price = models.DecimalField(verbose_name=_("stock price"), max_digits=24, decimal_places=4,
                                default='0.0000', help_text=_("Current stock price"))
    opening_price = models.DecimalField(verbose_name=_("opening price"), max_digits=24, decimal_places=4,
                                        null=True, blank=True, help_text=_("Opening price"))

    class Meta:
        verbose_name = _('stock')
        verbose_name_plural = _('stocks')
        ordering = ['symbol']

    def _last_quote(self):
        try:
            last_quote = self.quotes.all()[0]
        except IndexError:
            last_quote = None
        return last_quote
    last_quote = property(_last_quote)

    def _historical_prices(self):
        return stock_historical_prices(self.id)
    historical_prices = property(_historical_prices)

    def save(self, force_insert=False, force_update=False, using=None, update_fields=None):
        if self.price != 0 and not self.opening_price:
            print("Preparing opening: STOCK %s @ %s" % (self.symbol, self.price))
            # It's an update and we have the first quotation for this stock
            self.opening_price = self.price
            models.Model.save(self, force_insert, force_update, using, update_fields)
            set_opening_price.apply_async([self.id, self.price])
        else:
            models.Model.save(self, force_insert, force_update, using, update_fields)

    def __str__(self):
        return self.symbol


class Quote(models.Model):
    """
    Quotes are the price of a given stock at a certain time.
    """
    stock = models.ForeignKey('Stock', verbose_name=_("stock"), related_name="quotes", help_text=_("Related stock"))
    price = models.DecimalField(verbose_name=_("stock price"), max_digits=24, decimal_places=4,
                                default='0.0000', help_text=_("Current stock price"))
    timestamp = models.DateTimeField(verbose_name=_("timestamp"), auto_now_add=True, help_text=_("Timestamp of the quote"))
    sim_round = models.IntegerField(verbose_name=_("round"), default=0, help_text=_("Current round"))
    sim_day = models.IntegerField(verbose_name=_("day"), default=0, help_text=_("Current day"))

    class Meta:
        verbose_name = _('quote')
        verbose_name_plural = _('quotes')
        ordering = ['-timestamp']

    def __str__(self):
        return "%s@%s R%sD%s (%s)" % (self.stock, self.price, self.sim_round, self.sim_day, self.timestamp)

    def save(self, force_insert=False, force_update=False, using=None, update_fields=None):
        current = current_sim_day(self.stock.simulation_id)
        self.sim_round = current['sim_round']
        self.sim_day = current['sim_day']
        models.Model.save(self, force_insert, force_update, using, update_fields)


class HistoricalPrice(models.Model):
    """
    A summary of the quotes, updated each sim_day.
    """
    stock = models.ForeignKey('Stock', verbose_name=_("stock"), related_name="history", help_text=_("Related stock"))
    price_open = models.DecimalField(verbose_name=_("open"), max_digits=24, decimal_places=4,
                                     default='0.0000', help_text=_("Current stock price"))
    price_high = models.DecimalField(verbose_name=_("high"), max_digits=24, decimal_places=4,
                                     default='0.0000', help_text=_("Current stock price"))
    price_low = models.DecimalField(verbose_name=_("low"), max_digits=24, decimal_places=4,
                                    default='0.0000', help_text=_("Current stock price"))
    price_close = models.DecimalField(verbose_name=_("close"), max_digits=24, decimal_places=4,
                                      default='0.0000', help_text=_("Current stock price"))
    volume = models.IntegerField(verbose_name=_("volume"), help_text=_("Day volume"))
    sim_round = models.IntegerField(verbose_name=_("round"), default=0, help_text=_("Current round"))
    sim_day = models.IntegerField(verbose_name=_("day"), default=0, help_text=_("Current day"))
    timestamp = models.DateTimeField(verbose_name=_("timestamp"), auto_now_add=True, help_text=_("Timestamp of the historical price"))

    class Meta:
        verbose_name = _('historical price')
        verbose_name_plural = _('historical prices')
        ordering = ['-sim_round', '-sim_day']

    def __str__(self):
        return "%s R%sD%s O:%s | H:%s | L:%s | C:%s | V:%s" % (self.stock, self.sim_round, self.sim_day, self.price_open, self.price_high, self.price_low, self.price_close, self.volume)

    def save(self, force_insert=False, force_update=False, using=None, update_fields=None):
        self.sim_round = current_sim_day(self.stock.simulation_id)['sim_round']
        self.sim_day = current_sim_day(self.stock.simulation_id)['sim_day']
        models.Model.save(self, force_insert, force_update, using, update_fields)


class Order(models.Model):
    """
    Orders are made by teams and posted in the order book. They are then processed by the order manager.
    BID is the highest price that a buyer is willing to pay for a stock.
    ASK is the lowest price that a seller is willing to accept for a stock.
    """
    BID = 'BID'
    ASK = 'ASK'
    ORDER_TYPE_CHOICES = (
        (BID, _('bid')),
        (ASK, _('ask')),
    )

    SUBMITTED = 'SUBMITTED'
    PROCESSED = 'PROCESSED'
    FAILED = 'FAILED'
    ORDER_STATE_CHOICES = (
        (SUBMITTED, _('submitted')),
        (PROCESSED, _('processed')),
        (FAILED, _('failed')),
    )

    stock = models.ForeignKey('Stock', verbose_name=_("stock"), related_name="orders", help_text=_("Related stock"))
    team = models.ForeignKey(Team, verbose_name=_("team"), related_name="orders", help_text=_("Team which placed the order"))
    order_type = models.CharField(verbose_name=_("type of order"), max_length=5, choices=ORDER_TYPE_CHOICES,
                                  default=BID, help_text=_("The type of order (bid/ask)"))
    quantity = models.IntegerField(verbose_name=_("quantity ordered"), default=0, help_text=_("Quantity ordered. If the total quantity can not be provided, a new order will be created with the balance"))
    price = models.DecimalField(verbose_name=_("price tag"), max_digits=24, decimal_places=4,
                                blank=True, null=True, help_text=_("Price tag for one stock. If NULL, best available price"))
    created_at = models.DateTimeField(verbose_name=_("created"), auto_now_add=True, help_text=_("Creation of the order"))
    transaction = models.ForeignKey('Transaction', verbose_name=_("transaction"), related_name="orders", null=True,
                                    blank=True, help_text=_("Related transaction"))
    state = models.CharField(verbose_name=_("state of the order"), max_length=25, choices=ORDER_STATE_CHOICES,
                             default=SUBMITTED, help_text=_("The state of the order (submitted/processed/failed)"))
    sim_round = models.IntegerField(verbose_name=_("round"), default=0, help_text=_("Current round"))
    sim_day = models.IntegerField(verbose_name=_("day"), default=0, help_text=_("Current day"))
    timestamp = models.DateTimeField(verbose_name=_("updated"), auto_now=True, help_text=_("Last update of the order"))

    class Meta:
        verbose_name = _('order')
        verbose_name_plural = _('orders')

marmix/stocks/forms.py
# -*- coding: UTF-8 -*-
# forms.py
#
# Copyright (C) 2014 HES-SO//HEG Arc
#
# Author(s): Cédric Gaspoz <cedric.gaspoz@he-arc.ch>
#
# This file is part of MarMix.
#
# MarMix is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# MarMix is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with MarMix. If not, see <http://www.gnu.org/licenses/>.

# Stdlib imports

# Core Django imports
from django import forms

# Third-party app imports

# MarMix imports
#from .models import <model>


# class BarForm(forms.ModelForm):
#     """
#     BarForm
#     """
#     class Meta:
#         model = <model>
#         fields = '__all__'

marmix/templates/stocks/dividends_list.html
{%  extends "base.html" %}

{% block title %}
    {{ block.super }} > Dividends
{% endblock title %}

{% block content %}
<h1>Dividends</h1>

{% include "simulations/includes/clock.html" with clock=clock %}

<table class="table table-striped">
<thead>
<tr>
    <th>Round</th>
    <th>Stock</th>
    <th>Price</th>
    <th>Quantity</th>
    <th>Amount</th>
</tr>
</thead>
<tbody>
{% for transaction in transactions %}
    <tr>
        <td>R{{ transaction.transaction.sim_round }}</td>
        <td>{{ transaction.stock.symbol }}</td>
        <td>{{ transaction.price|stringformat:".2f" }}</td>
        <td>{{ transaction.quantity }}</td>
        <td>{{ transaction.amount|stringformat:".2f" }}</td>
    </tr>
{% empty %}
    <tr><td colspan="5">No dividends yet.</td></tr>
{% endfor %}
</tbody>
</table>

{% endblock content %}

marmix/templates/stocks/order_confirm_delete.html
{%  extends "base.html" %}
{% load crispy_forms_tags %}

{% block title %}
    {{ block.super }} > Delete the order
{% endblock title %}

{% block content %}

<h1>Delete order {{ object.code }}</h1>

<form action="{% url 'order-delete-view' object.id %}" method="post">{% csrf_token %}
    <p>Are you sure that you want to delete the following order?</p>
    <dl class="dl-horizontal">
    <dt>Stock</dt>
    <dd>{{ object.stock }}</dd>
    <dt>Type</dt>
    <dd>{{ object.get_order_type_display|capfirst }}</dd>
    <dt>Quantity</dt>
    <dd>{{ object.quantity }}</dd>
    <dt>Price</dt>
    <dd>{{ object.price }}</dd>
    <dt>Created at</dt>
    <dd>{{ order.created_at|date:"SHORT_DATETIME_FORMAT" }}</dd>
    </dl>
    <button type="submit" class="btn btn-danger"><i class="fa fa-trash-o"></i> Delete this order</button>
</form>
{% endblock content %}

marmix/templates/stocks/order_form.html
{%  extends "base.html" %}
{% load crispy_forms_tags %}

{% block title %}
    {{ block.super }} > Create new simulation
{% endblock title %}

{% block content %}
<form action="{% if action == 'create' %}{% url 'order-create-view' %}{% elif action == 'update' %}{% url 'order-update-view' order_id %}{% endif %}" method="post">{% csrf_token %}
    {{ form|crispy }}
    {% if action == 'create' %}
        <button type="submit" class="btn btn-success"><i class="fa fa-check-square-o"></i> Submit order</button>
    {% elif action == 'update' %}
        <button type="submit" class="btn btn-success"><i class="fa fa-check-square-o"></i> Update order</button>
    {% endif %}
</form>
{% endblock content %}

marmix/templates/stocks/order_list.html
{%  extends "base.html" %}

{% block title %}
    {{ block.super }} > Orders
{% endblock title %}

{% block content %}
<h1>Orders</h1>
<a class="btn btn-primary" href="{% url 'order-create-view' %}"><i class="fa fa-plus-square-o fa-lg"></i> Create order</a>

{% include "stocks/includes/orders_table.html" with orders=object_list %}

{% endblock content %}

marmix/templates/stocks/stock_detail.html
{%  extends "base.html" %}

{% block title %}
    {{ block.super }} > Stock detail
{% endblock title %}

{% block content %}
<h1>{{ object.name }}</h1>
<dl>
    <dt>Symbol</dt>
    <dd>{{ object.symbol }}</dd>
    <dt>Quantity</dt>
    <dd>{{ object.quantity }}</dd>
</dl>
<p>{{ object.description|safe }}</p>

<table class="table table-striped">
<thead>
<tr>
    <th>Day</th>
    <th>Open</th>
    <th>High</th>
    <th>Low</th>
    <th>Close</th>
    <th>Volume</th>
</tr>
</thead>
<tbody>
{% for day in object.historical_prices %}
<tr>
    <td>R{{ day.sim_round }}D{{ day.sim_day }}</td>
    <td>{{ day.price_open|stringformat:".2f" }}</td>
    <td>{{ day.price_high|stringformat:".2f" }}</td>
    <td>{{ day.price_low|stringformat:".2f" }}</td>
    <td>{{ day.price_close|stringformat:".2f" }}</td>
    <td>{{ day.volume }}</td>
</tr>
{% empty %}
<tr>
    <td colspan="2">No current quote for this stock</td>
</tr>
{% endfor %}
</tbody>
</table>

<a href="{% url 'stocks-list-view' %}">Back</a>
{% endblock content %}

marmix/templates/stocks/stock_list.html
{%  extends "base.html" %}

{% block title %}
    {{ block.super }} > Stocks
{% endblock title %}

{% block content %}
<h1>Stocks</h1>
<ul>
{% for stock in object_list %}
    <li><a href="{% url 'stocks-detail-view' stock.id %}">{{ stock.symbol }}</a> - {{ stock.name }} ({{ stock.quantity }})</li>
{% empty %}
    <li>No stocks yet.</li>
{% endfor %}
</ul>
{% endblock content %}

marmix/templates/stocks/transactionline_list.html
{%  extends "base.html" %}

{% block title %}
    {{ block.super }} > Holdings
{% endblock title %}

{% block content %}
<h1>Holdings</h1>

{% include "simulations/includes/clock.html" with clock=clock %}

{% with lists=team.get_holdings %}
<table class="table table-striped">
<thead>
<tr>
    <th>Stock</th>
    <th>Quantity</th>
    <th>Quote</th>
    <th>Market value</th>
    <th>Purchase Value</th>
    <th>Gain</th>
    <th>Gain %</th>
    <th></th>
</tr>
</thead>
<tbody>
{% for stock in lists.stocks %}
    <tr>
        <td>
            {% if stock.asset_type == 'STOCKS' %}
                <a href="{% url 'stocks-detail-view' stock.stock_id %}">{{ stock.symbol }}</a>
            {% else %}
                {{ stock.asset|capfirst }}
            {% endif %}
        </td>
        <td>{{ stock.quantity }}</td>
        <td>{{ stock.price|stringformat:".2f" }}</td>
        <td>{{ stock.value|stringformat:".2f" }}</td>
        <td>{{ stock.amount|stringformat:".2f" }}</td>
        <td{% if stock.gain > 0 %} class="gain"{% elif stock.gain < 0 %} class="loss"{% endif %}>{{ stock.gain|stringformat:".2f" }}</td>
        <td{% if stock.gain > 0 %} class="gain"{% elif stock.gain < 0 %} class="loss"{% endif %}>{{ stock.gain_p|stringformat:".1f" }}%</td>
        <td></td>
    </tr>
{% empty %}
    <tr><td colspan="8">No stocks yet.</td></tr>
{% endfor %}
{% for cash in lists.cash %}
    <tr>
        <td colspan="3">{{ cash.asset|capfirst }}</td>
        <td>{{ cash.value|stringformat:".2f" }}</td>
        <td>{{ cash.amount|stringformat:".2f" }}</td>
        <td></td>
        <td></td>
        <td></td>
    </tr>
{% empty %}
    <tr><td colspan="8">No cash yet.</td></tr>
{% endfor %}
{% if lists.cash or lists.stocks %}
    <tr>
        <td colspan="3">Balance</td>
        <td>{{ lists.balance.market_value|stringformat:".2f" }}</td>
        <td>{{ lists.balance.purchase_value|stringformat:".2f" }}</td>
        <td{% if lists.balance.gain > 0 %} class="gain"{% elif stock.gain < 0 %} class="loss"{% endif %}>{{ lists.balance.gain|stringformat:".2f" }}</td>
        <td{% if lists.balance.gain > 0 %} class="gain"{% elif stock.gain < 0 %} class="loss"{% endif %}>{{ lists.balance.gain_p|stringformat:".1f" }}%</td>
        <td></td>
    </tr>
{% endif %}
</tbody>
</table>
{% endwith %}

<h1>Orders</h1>
<a class="btn btn-primary" href="{% url 'order-create-view' %}"><i class="fa fa-plus-square-o fa-lg"></i> Create order</a>

{% include "stocks/includes/orders_table.html" with orders=orders %}

{% endblock content %}